<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<title>EasyThumbs</title>
	<style type="text/css">
	body {
		background:#eeeeee;
		margins:10px;
		font-family:arial,sans serif;
		font-size:.8em;
		color:#333333;
	}
	a {
		color:#336699;
		text-decoration:underline;
	}
	</style>
</head>
<body>
<?php
/*
	EasyThumbs 
	Version 2.2
	written by Christian Heilmann
	Homepage:http://www.onlinetools.org/tools/easythumbs.php
	Do not alter anything in here, this script is template driven!!!!
*/

// Loading the templates, buffering for reuse
$branding="Generated with EasyThumbs (http://www.onlinetools.org/)";
$HTML=load("easythumbs_template.html");
$big=load("easythumbs_bigtemplate.html");
$bufferHTML=$HTML;
$bufferbig=$big;

// gather settings data from template
preg_match("/<!-- images:(.*?) -->/",$HTML,$filter);
preg_match("/<!-- imagesfolder:(.*?) -->/",$HTML,$picdir);
preg_match("/<!-- imagesinrow:(.*?) -->/",$HTML,$maxrowimg);
preg_match("/<!-- imagesonpage:(.*?) -->/",$HTML,$maxpageimg);
preg_match("/<!-- pagename:(.*?) -->/",$HTML,$pagename);
preg_match("/<!-- imagepagename:(.*?) -->/",$HTML,$imagepagename);
preg_match("/<!-- thumbnailfilter:(.*?) -->/",$HTML,$thumbnailfilter);
preg_match("/<!-- start:break -->(.*?)<!-- end:break -->/si",$HTML,$break);
// get image names, filter out thumbnails
if ($picdir[1]=="") {$picdir[1]="./";}
$pics=directory($picdir[1],$filter[1]);
$pics=namefilter($pics,$thumbnailfilter[1]);
sort($pics);
echo "<b>EasyThumbs</b> generates pages...\n<br /><br />";
echo "Found ".count($pics). " images.<br /><br />";
echo "<b>Settings:</b><br /><br />";
echo "<b>Allowed image types:</b> $filter[1]<br />";
echo "<b>Imagesfolder:</b> $picdir[1]<br />";
echo "<b>Images per row:</b> $maxrowimg[1]<br />";
echo "<b>Images per page:</b> $maxpageimg[1]<br />";
echo "<b>Pagename:</b> $pagename[1]<br />";
echo "<b>Imagepagename:</b> $imagepagename[1]<br />";
echo "<b>Thumbnailfilter:</b> $thumbnailfilter[1]<br />";
echo "<b>BreakHTML:</b> ".htmlspecialchars($break[1])."<br /><br />";
$start=0;
while ($start < sizeof($pics)){
	echo "Generated ".str_replace(".",$f.".",$pagename[1])."<br />";
	$tab="";
	preg_match_all("/<!-- start:image -->(.*?)<!-- end:image -->/si",$HTML,$imgTemp);
	$i=0;
	while($i < $maxpageimg[1] ){
		$p=$pics[$start+$i];
		if ($p !=""){
			$img=preg_replace("/%pic%/",$p,$imgTemp[1][0]);
			$img=preg_replace("/%name%/",preg_replace("/\.\D{0,4}|_/"," ",$p),$img);
			$img=preg_replace("/%imagecounter%/",$start+$i,$img);
			$tab.=$img;
			preg_match_all("/<!-- start:image -->(.*?)<!-- end:image -->/si",$big,$bigimgTemp);
			$bigimg=str_replace("%sourcepage%",str_replace(".",$f.".",$pagename[1]),$bigimgTemp[1][0]);
			$bigsize=getimagesize($picdir[1].$p);
			$bigimg=preg_replace("/%name%/",preg_replace("/\.\D{0,4}|_/"," ",$p),$bigimg);
			$bigimg=str_replace("%pic%",$picdir[1].$p,$bigimg);
			$bigimg=str_replace("%size%",$bigsize[3],$bigimg);
			$bigprev=str_replace(".",($start+$i-1).".",$imagepagename[1]);
			$bignext=str_replace(".",($start+$i+1).".",$imagepagename[1]);
			$big=preg_replace("/<!-- start:image -->(.*?)<!-- end:image -->/si",$bigimg,$big);
			$big=str_replace("%previous%",$bigprev,$big);
			$big=str_replace("%next%",$bignext,$big);
			$big=str_replace("%image%",$start+$i+1,$big);
			$big=str_replace("%numberofimages%",count($pics),$big);
			$big=str_replace("%first%",str_replace(".","0.",$imagepagename[1]),$big);
			$big=str_replace("%last%",str_replace(".",(count($pics)-1).".",$imagepagename[1]),$big);
			if ($start+$i-1<0){
				$big=preg_replace("/<!-- start:previous -->.*?<!-- end:previous -->/si","",$big);
				$big=preg_replace("/<!-- start:first -->.*?<!-- end:first -->/si","",$big);
			}
			if ($start+$i+1>count($pics)-1){
				$big=preg_replace("/<!-- start:next -->.*?<!-- end:next -->/si","",$big);
				$big=preg_replace("/<!-- start:last -->.*?<!-- end:last -->/si","",$big);
			}
			$big=preg_replace("/<!-- (.*?) -->/s","",$big);
			$big=preg_replace("/%branding%/",$branding,$big);
			$big=preg_replace("/<head>/si","<head>\n<meta generator=\"EasyThumbs (http://www.onlinetools.org/)\" />\n",$big);	
			$big=preg_replace("/<\/body/si","\n<!-- Generated with EasyThumbs (http://www.onlinetools.org/) -->\n</body",$big);	
			save(str_replace(".",($start+$i).".",$imagepagename[1]),$big);
			echo "&nbsp;&nbsp;&nbsp;Generated ".str_replace(".",($start+$i).".",$imagepagename[1])."<br />";
			$big=$bufferbig;
		}
		if (($i+1)%$maxrowimg[1] == 0 and ($i+1)!=$maxpageimg[1] and $pics[$start+$i+1]!=""){$tab.=$break[1];}
		$i++;
	}
	$start+=$i;
	$nextcount=str_replace(".",($f+1).".",$pagename[1]);
	if($f>1){$prevcount=str_replace(".",($f-1).".",$pagename[1]);}
	else{$prevcount=$pagename[1];}
	$HTML=preg_replace("/<!-- start:image -->(.*?)<!-- end:image -->/si",$tab,$HTML);
	$HTML=preg_replace("/%next%/",$nextcount,$HTML);
	$HTML=preg_replace("/%first%/",$pagename[1],$HTML);
	$term=count($pics)/$maxpageimg[1];
	if (is_int($term)){$endvar=$term-1;echo"$term";}else{$endvar=(int)$term;}
	$HTML=preg_replace("/%last%/",str_replace(".",$endvar.".",$pagename[1]),$HTML);
	$HTML=preg_replace("/%previous%/",$prevcount,$HTML);
	if ($f<1){
		$HTML=preg_replace("/<!-- start:back -->(.*?)<!-- end:back -->/si","",$HTML);
		$HTML=preg_replace("/<!-- start:first -->(.*?)<!-- end:first -->/si","",$HTML);
	}
	if($start >= sizeof($pics)){
		$HTML=preg_replace("/<!-- start:next -->(.*?)<!-- end:next -->/si","",$HTML);
		$HTML=preg_replace("/<!-- start:last -->(.*?)<!-- end:last -->/si","",$HTML);
	}
	$HTML=preg_replace("/%allpages%/",$endvar+1,$HTML);
	$HTML=preg_replace("/%page%/",$f+1,$HTML);
	$HTML=preg_replace("/<!-- start:break -->(.*?)<!-- end:break -->/si","",$HTML);
	$HTML=preg_replace("/%branding%/",$branding,$HTML);
	$HTML=preg_replace("/<!-- (.*?) -->/s","",$HTML);	
	$HTML=preg_replace("/<head>/si","<head>\n<meta generator=\"EasyThumbs (http://www.onlinetools.org/)\" />\n",$HTML);	
	$HTML=preg_replace("/<\/body/si","\n<!-- Generated with EasyThumbs (http://www.onlinetools.org/) -->\n</body",$HTML);	
	save(str_replace(".",$f.".",$pagename[1]),$HTML);
	$f++;
	$HTML=$bufferHTML;
}
echo "Click <a href=\"$pagename[1]\">here</a> to see the gallery";

/*
        Function load($file)
        reads the content of the file that you send and returns it
*/
function load($filelocation){
        if (file_exists($filelocation)){
                $newfile = fopen($filelocation,"r");
                $file_content = fread($newfile, filesize($filelocation));
                fclose($newfile);
                return $file_content;
                }
        }

/*
        Function save($file,$content)
        writes the content to the file and generates it if needed
*/
function save($filelocation,$newdatas){
        $newfile = fopen($filelocation,"w+");
        fwrite($newfile, $newdatas);
        fclose($newfile);
        }

/*
        Function namefiler($array,$filter)
        filters out all the items that apply to filter and returns the cleaned array
*/
function namefilter($array,$filter){
        $temparray=array();
        foreach ($array as $r){
           if (!preg_match("/".$filter."/",$r)){$temparray[]=$r;}
		}
        return $temparray;
        }

/*
        Function directory($directory,$filters)
        reads the content of $directory, takes the files that apply to $filter and returns an
        array of the filenames.
        You can specify which files to read, for example
        $files = directory(".","jpg,gif");
                gets all jpg and gif files in this directory.
        $files = directory(".","all");
                gets all files.
*/
function directory($dir,$filters){
        $handle=opendir($dir);
        $files=array();
        if ($filters == "all"){while(($file = readdir($handle))!==false){$files[] = $file;}}
        if ($filters != "all"){
                $filters=explode(",",$filters);
                while (($file = readdir($handle))!==false) {
                        for ($f=0;$f<sizeof($filters);$f++):
                                $system=explode(".",$file);
                                if ($system[1] == $filters[$f]){$files[] = $file;}
                        endfor;
                }
        }
        closedir($handle);
        return $files;
        }
?>
</body>
</html>